"""
Copyright (C) 2019 Cumulus Networks, Inc. all rights reserved

This software is subject to the Cumulus Networks End User License Agreement available
at the following locations:

Internet: https://cumulusnetworks.com/downloads/eula/latest/view/
Cumulus Linux systems: /usr/share/cumulus/EULA.txt
"""

import re
import logging
from pprint import pformat

"""
parser for ethtool -m swpXX hex on
"""

this_log = logging.getLogger(__name__)
debug    = this_log.debug
info     = this_log.info
warn     = this_log.warning
error    = this_log.error

name = "ethtool -m hex on"


def parse(command, output):
    """
    Return a dictionary or list containing the values parsed from the output
    If parse failed, return None


    """
    # mlx: Cannot get Module EEPROM data: Invalid argument
    # bcm: Cannot get module EEPROM information
    no_eeprom_key = re.compile(r'''Cannot\sget\s[mM]odule\sEEPROM''')
    identifier_zero = re.compile(r'''0x00\s\(no\smodule\spresent,\sunknown,\sor\sunspecified\)''')

    hex_data = []


    for line in output.split('\n'):
        if no_eeprom_key.search(line) or identifier_zero.search(line):
            return None

        if "0x" not in line: continue
        hex_data += line.split(':\t', 1)[1].strip().split(' ')

    hex_data = "".join(map(lambda x: chr(int(x.strip()[0], 16)*16 + int(x.strip()[1], 16)), hex_data))

    debug('hex_data:' + pformat(hex_data))
    return hex_data
